<template>
  <v-alert
      v-if="success"
      type="success"
      closable
      title="รีเซ็ตรหัสผ่านเรียบร้อย"
  />
  <div class="container">
    <v-card class="card">

      <h2 class="text-center mb-6 mt-2">รีเซ็ตรหัสผ่าน</h2>
      <v-form @submit.prevent="onSubmit" class="form">

        <v-text-field
            v-if="isLoaded"
            v-model="password"
            :rules="[passwordRules.required, passwordRules.min]"
            :type="visible1 ? 'text' : 'password'"
            :append-inner-icon="visible1 ? 'mdi-eye-off' : 'mdi-eye'"
            @click:append-inner="visible1 = !visible1"
            label="รหัสผ่าน"
            placeholder="Password"
            variant="solo"
            rounded="xl"
            density="comfortable"
            counter
            clearable
        ></v-text-field>
        <v-text-field
            v-if="isLoaded"
            v-model="confirmpassword"
            :rules="[
            passwordRules.required,
            passwordRules.min,
            passwordRules.match,
          ]"
            :type="visible2 ? 'text' : 'password'"
            :append-inner-icon="visible2 ? 'mdi-eye-off' : 'mdi-eye'"
            @click:append-inner="visible2 = !visible2"
            label="ยืนยัน-รหัสผ่าน"
            placeholder="Confirm Password"
            variant="solo"
            rounded="xl"
            density="comfortable"
            counter
            clearable
        ></v-text-field>

        <v-btn
            :loading="loadingbtn"
            :disabled="!isFormValid"
            type="submit"
            block
            class="submit-btn"
            size="large"
            variant="flat"
            rounded="xl"
        >ยืนยัน
        </v-btn>
      </v-form>
    </v-card>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | รีเซ็ตรหัสผ่าน",
  meta: [{name: "description", content: "รีเซ็ตรหัสผ่าน"}],
});
// ปิด layout
definePageMeta({
  layout: false,
});

import {ref, onMounted} from 'vue';

const {resetPassword} = useStrapiAuth()
const router = useRouter()

const code = ref(router.currentRoute.value.query.code)
const password = ref();
const confirmpassword = ref();

const visible1 = ref(false);
const visible2 = ref(false);
const success = ref(false);
const loadingbtn = ref(false);
const isLoaded = ref()

const passwordRules = {
  required: (value) => !!value || "กรุณากรอกรหัสผ่านใหม่",
  min: (v) => v.length >= 8 || "อย่างน้อย 8 ตัวอักษร",
  match: () => confirmpassword.value === password.value || "รหัสผ่านไม่ตรงกัน",
};

const isFormValid = computed(() => {
  return (
      !!password.value &&
      !!confirmpassword.value &&
      ispasswordValid(password.value, confirmpassword.value)
  );
});

const ispasswordValid = (password, confirmpassword) => {
  const isLengthValid = password.length >= 8;
  const isMatchValid = password === confirmpassword;
  return isLengthValid && isMatchValid;
};

console.log("My code value : ",code)
async function onSubmit() {
  loadingbtn.value = true;
  setTimeout(() => (loadingbtn.value = false), 2000);

  try {
    await resetPassword({ code: code.value, password: password.value, passwordConfirmation: confirmpassword.value })
    success.value = true;
    await new Promise(resolve => setTimeout(resolve, 2000));
    success.value = false;

    router.push('/login')
  } catch (e) {}
}

onMounted(async () => {
  isLoaded.value = true;
});
</script>

<style scoped>
@import url(../assets/css/styles/form-card.css);
</style>